## smlnj 110.62

=== ml-antlr/Makefile ===
#
# COPYRIGHT (c) 2006
# John Reppy (http://www.cs.uchicago.edu/~jhr)
# Aaron Turon (http://www.cs.uchicago.edu/~adrassi)
# All rights reserved.
#

OS =		$(shell uname -s)

ifeq ($(shell uname -s),Darwin)
HEAP_SUFFIX =		ppc-darwin
else
HEAP_SUFFIX =		x86-linux
endif

SHELL =			/bin/sh
SML =			sml
ML_BUILD =		ml-build
ML_MAKEDEPEND =		ml-makedepend

PROGRAM =	ml-antlr
HEAP_IMAGE =	$(PROGRAM).$(HEAP_SUFFIX)

FE = 		FrontEnds
BE = 		BackEnds

SML_SRC = 	$(wildcard $(BE)/SML/*.sml)
LATEX_SRC =     $(wildcard $(BE)/LaTeX/*.sml)

FE_SRC = 	$(wildcard $(FE)/*.sml)  $(FE)/ml-yacc-based/spec.grm $(FE)/ml-yacc-based/spec.lex
BE_SRC = 	$(wildcard $(BE)/*.sml) $(SML_SRC) $(LATEX_SRC)

TEMPLATES =     $(BE)/SML/template.sml $(BE)/LaTeX/template.tex

CORE_SRC =	$(wildcard *.sml)

SOURCES =	$(CORE_SRC) $(FE_SRC) $(BE_SRC) $(TEMPLATES) sources.cm

build:		$(HEAP_IMAGE)

$(HEAP_IMAGE):	$(SOURCES)
	$(ML_BUILD) sources.cm Main.main $(PROGRAM)

.depend:	$(CM_FILES)
	touch .depend
	$(ML_MAKEDEPEND) -n -f .depend sources.cm $(HEAP_IMAGE)

sinclude .depend

clean:
	rm -rf .depend .cm FrontEnds/ml-yacc-based/spec.lex.sml FrontEnds/ml-yacc-based/spec.grm.sig FrontEnds/ml-yacc-based/spec.grm.sml $(HEAP_IMAGE)

devclean:
	rm -rf $(HEAP_IMAGE)

=== src/Makefile ===
#
# COPYRIGHT (c) 2005 
# John Reppy (http://www.cs.uchicago.edu/~jhr)
# Aaron Turon (adrassi@gmail.com)
# All rights reserved.
#

OS =		$(shell uname -s)

ifeq ($(shell uname -s),Darwin)
HEAP_SUFFIX =		ppc-darwin
else
HEAP_SUFFIX =		x86-unix
endif

SHELL =			/bin/sh
SML =			sml
ML_BUILD =		ml-build
ML_MAKEDEPEND =		ml-makedepend

PROGRAM =	lexgen
HEAP_IMAGE =	$(PROGRAM).$(HEAP_SUFFIX)

FE = 		FrontEnds
BE = 		BackEnds

ML_LEX =	$(FE)/ml-lex
ML_LEX_SRC = 	$(wildcard $(ML_LEX)/*.sml) $(ML_LEX)/ml-lex.lex $(ML_LEX)/ml-lex.yacc

DUMP_SRC =	$(wildcard $(BE)/Dump/*.sml)
DOT_SRC =	$(wildcard $(BE)/Dot/*.sml)
SML_SRC = 	$(wildcard $(BE)/SML/*.sml)
MATCH_SRC = 	$(wildcard $(BE)/Match/*.sml)

FE_SRC = 	$(wildcard $(FE)/*.sml) $(ML_LEX_SRC)
BE_SRC = 	$(wildcard $(BE)/*.sml) $(DOT_SRC) $(SML_SRC) $(MATCH_SRC)

CORE_SRC =	$(wildcard *.sml)

SOURCES =	$(CORE_SRC) $(FE_SRC) $(BE_SRC) sources.cm

build:		$(HEAP_IMAGE)

$(HEAP_IMAGE):	$(SOURCES)
	$(ML_BUILD) sources.cm Main.main $(PROGRAM)

.depend:	$(CM_FILES)
	touch .depend
	$(ML_MAKEDEPEND) -n -f .depend sources.cm $(HEAP_IMAGE)

sinclude .depend

#NOTE: do NOT clean out ml-lex.lex.sml, it is not autogenerated!
clean:
	rm -rf .depend .cm FrontEnds/ml-lex/ml-lex.yacc.sml $(HEAP_IMAGE)

## smlnj 110.65

=== ml-antlr/Makefile ===
--- 
+++ 
@@ -27,7 +27,7 @@
 SML_SRC = 	$(wildcard $(BE)/SML/*.sml)
 LATEX_SRC =     $(wildcard $(BE)/LaTeX/*.sml)
 
-FE_SRC = 	$(wildcard $(FE)/*.sml)  $(FE)/ml-yacc-based/spec.grm $(FE)/ml-yacc-based/spec.lex
+FE_SRC = 	$(wildcard $(FE)/*.sml)  $(FE)/ml-antlr-based/spec.grm $(FE)/ml-antlr-based/spec.lex
 BE_SRC = 	$(wildcard $(BE)/*.sml) $(SML_SRC) $(LATEX_SRC)
 
 TEMPLATES =     $(BE)/SML/template.sml $(BE)/LaTeX/template.tex
@@ -48,7 +48,7 @@
 sinclude .depend
 
 clean:
-	rm -rf .depend .cm FrontEnds/ml-yacc-based/spec.lex.sml FrontEnds/ml-yacc-based/spec.grm.sig FrontEnds/ml-yacc-based/spec.grm.sml $(HEAP_IMAGE)
+	rm -rf .depend .cm $(HEAP_IMAGE)
 
 devclean:
 	rm -rf $(HEAP_IMAGE)

=== ml-ulex/Makefile ===
#
# COPYRIGHT (c) 2005 
# John Reppy (http://www.cs.uchicago.edu/~jhr)
# Aaron Turon (adrassi@gmail.com)
# All rights reserved.
#

OS =		$(shell uname -s)

ifeq ($(shell uname -s),Darwin)
HEAP_SUFFIX =		ppc-darwin
else
HEAP_SUFFIX =		x86-unix
endif

SHELL =			/bin/sh
SML =			sml
ML_BUILD =		ml-build
ML_MAKEDEPEND =		ml-makedepend

PROGRAM =	ml-ulex
HEAP_IMAGE =	$(PROGRAM).$(HEAP_SUFFIX)

FE = 		FrontEnds
BE = 		BackEnds

ML_LEX =	$(FE)/ml-lex
ML_LEX_SRC = 	$(wildcard $(ML_LEX)/*.sml) $(ML_LEX)/ml-lex.lex $(ML_LEX)/ml-lex.yacc

ML_ULEX =	$(FE)/ml-ulex
ML_ULEX_SRC = 	$(wildcard $(ML_ULEX)/*.sml) $(ML_ULEX)/ml-ulex.lex $(ML_ULEX)/ml-ulex.grm

DUMP_SRC =	$(wildcard $(BE)/Dump/*.sml)
DOT_SRC =	$(wildcard $(BE)/Dot/*.sml)
SML_SRC = 	$(wildcard $(BE)/SML/*.sml)
MATCH_SRC = 	$(wildcard $(BE)/Match/*.sml)

FE_SRC = 	$(wildcard $(FE)/*.sml) $(ML_LEX_SRC) $(ML_ULEX_SRC)
BE_SRC = 	$(wildcard $(BE)/*.sml) $(DOT_SRC) $(SML_SRC) $(MATCH_SRC)

CORE_SRC =	$(wildcard *.sml)

SOURCES =	$(CORE_SRC) $(FE_SRC) $(BE_SRC) sources.cm

build:		$(HEAP_IMAGE)

$(HEAP_IMAGE):	$(SOURCES)
	$(ML_BUILD) sources.cm Main.main $(PROGRAM)

.depend:	$(CM_FILES)
	touch .depend
	$(ML_MAKEDEPEND) -n -f .depend sources.cm $(HEAP_IMAGE)

sinclude .depend

#NOTE: do NOT clean out ml-lex.lex.sml, it is not autogenerated!
clean:
	rm -rf .depend .cm FrontEnds/ml-lex/ml-lex.yacc.sml $(HEAP_IMAGE)

## smlnj 110.74

=== Makefile ===
arch_n_opsys := $(shell ../../bin/.arch-n-opsys)
ARCH := $(shell eval "$(arch_n_opsys)"; echo -n $$ARCH)
HEAP_SUFFIX := $(shell eval "$(arch_n_opsys)"; echo -n $$HEAP_SUFFIX)
BINDIR_SUFFIX=$(ARCH)-unix

# don't ask me why bindir_suffix <> heap_suffix
SML=sml.$(HEAP_SUFFIX)
BINDIR=bin.$(BINDIR_SUFFIX)
MLCMD=CMB.make()

default: sml
sml: $(SML)
sml-new: sml-new.$(HEAP_SUFFIX)

$(BINDIR).new:
	if [ -d $(BINDIR) ]; then \
	    mv $(BINDIR) $(BINDIR).new && mv $(BINDIR).old $(BINDIR) ;\
	else \
	    mkdir $(BINDIR).new ;\
	fi

$(SML): $(BINDIR)/COMPLIST
	-rm -f $@
	./xmakeml
	[ -r $(SML) ]

$(BINDIR)/COMPLIST: $(BINDIR).new

cleannew: $(BINDIR).new
	-rm -r $(BINDIR).new/*

recompile: $(SML)
	mv $(BINDIR) $(BINDIR).old && mv $(BINDIR).new $(BINDIR)
	-echo '$(MLCMD); Compiler.Stats.summary();' | ./xrun sml
	mv $(BINDIR) $(BINDIR).new && mv $(BINDIR).old $(BINDIR)

sml-new.$(HEAP_SUFFIX): recompile
	mv $(BINDIR) $(BINDIR).old && mv $(BINDIR).new $(BINDIR)
	if [ -f $(BINDIR)/COMPLIST ]; then \
	    mv $(SML) sml-old.$(HEAP_SUFFIX) &&\
	    ./xmakeml &&\
	    mv $(SML) sml-new.$(HEAP_SUFFIX) &&\
	    mv sml-old.$(HEAP_SUFFIX) $(SML) ;\
	fi
	mv $(BINDIR) $(BINDIR).new && mv $(BINDIR).old $(BINDIR)

run: $(SML)
	mv $(BINDIR) $(BINDIR).old && mv $(BINDIR).new $(BINDIR)
	./xrun $(SML)
	mv $(BINDIR) $(BINDIR).new && mv $(BINDIR).old $(BINDIR)

## smlnj 110.76

=== gen/Makefile ===
# Makefile
#
# COPYRIGHT (c) 2009 The Fellowship of SML/NJ (http://www.smlnj.org)
# All rights reserved.
#

SHELL =		/bin/sh

MLTON =		mlton
MLTON_FLAGS =

TARGET =	gen-template-struct

SOURCES =	gen-template-struct.mlb \
		gen-template-struct.sml \
		mlton-main.sml

$(TARGET):	$(SOURCES)
	$(MLTON) -output $(TARGET) $(MLTON_FLAGS) $(TARGET).mlb

.PHONEY:	clean
clean:
	rm -f $(TARGET)

=== c-call/varargs/interp/Makefile ===
# Build a shared object for the interpreter.

X86_C_FLAGS=-m32 -g3 -march=i686 -fPIC

build-x86-linux: vararg-interp-x86-linux.s util.c
	gcc -shared $(X86_C_FLAGS) util.c vararg-interp-x86-linux.s -o vararg

test-x86-linux: vararg-interp-x86-linux.s util.c test.c
	gcc -shared $(X86_C_FLAGS) util.c test.c -o vararg

build-x86-darwin: vararg-interp-x86-darwin.s util.c
	gcc $(X86_C_FLAGS) -c vararg-interp-x86-darwin.s
	gcc $(X86_C_FLAGS) -c util.c
	gcc -dynamiclib $(X86_C_FLAGS) util.o vararg-interp-x86-darwin.o -o vararg

test-x86-darwin: vararg-interp-x86-darwin.s util.c test.c
	gcc $(X86_C_FLAGS) -c test.c	
	gcc $(X86_C_FLAGS) -c util.c
	gcc -dynamiclib $(X86_C_FLAGS) util.o test.o -o vararg

interp-x86-darwin: vararg-interp-x86-darwin.s util.c test-interp.c
	gcc $(X86_C_FLAGS) -c test-interp.c	
	gcc $(X86_C_FLAGS) -c util.c
	gcc $(X86_C_FLAGS) -c vararg-interp-x86-darwin.s
	gcc $(X86_C_FLAGS) util.o test-interp.o vararg-interp-x86-darwin.o -o interp

AMD64_C_FLAGS=-m32 -g3

build-amd64-linux: vararg-interp-amd64.s util.c
	gcc -shared $(AMD64_C_FLAGS) util.c vararg-interp-amd64.s -o vararg

build-amd64-darwin: vararg-interp-amd64.s util.c
	gcc -dynlib $(AMD64_C_FLAGS) util.c vararg-interp-amd64.s -o vararg

## smlnj 110.78

=== MLRISC/Doc/html/Makefile ===
#
# This file compiles the documentation 
#

HTML=	mlrisc.html mltexdoc.html


TEX=    ../latex/annotations.tex \
	../latex/graphics.tex \
	../latex/instructions.tex \
	../latex/mltree.tex \
	../latex/delayslots.tex \
	../latex/cells.tex \
	../latex/cluster.tex \
	../latex/constants.tex \
	../latex/pseudo-ops.tex \
	../latex/streams.tex \
	../latex/labelexp.tex \
	../latex/labels.tex \
	../latex/regions.tex \
	../latex/regmap.tex \
	../latex/graphs.tex \
	../latex/mlrisc-ir.tex \
	../latex/compiler-graphs.tex \
	../latex/SSA.tex \
	../latex/VLIW.tex \
	../latex/ra.tex \
	../latex/ILP.tex \
	../latex/mlrisc-arch.tex \
	../latex/future-work.tex \
	../latex/asm.tex \
	../latex/mc.tex \
	../latex/span-dep.tex \
	../latex/instrsel.tex \
	../latex/availability.tex \
	../latex/gc.tex \
	../latex/mlrisc-gen.tex \
	../latex/contributions.tex \
	../latex/systems.tex \
	../latex/mlrisc-graphics.tex \
	../latex/contributors.tex \
	../latex/requirements.tex \
	../latex/INTRO.tex \
	../latex/problem.tex \
	../latex/mlrisc-compiler.tex \
	../latex/mlrisc-ir-rep.tex \
	../latex/backend-opt.tex \
	../latex/sys-integration.tex \
	../latex/optimizations.tex \
	../latex/span-dep.tex \
	../latex/mlrisc-md.tex \
	../latex/mlrisc-ra.tex \
	../latex/line-counts.tex \
	../latex/sparc.tex \
	../latex/alpha.tex \
	../latex/x86.tex \
	../latex/ppc.tex \
	../latex/mips.tex \
	../latex/hppa.tex \
	../latex/C6.tex \
	../latex/mltree-ext.tex \
	../latex/mltree-util.tex 

all:	pictures $(HTML) makelinks

pictures:
	(cd ../pictures; make)

cvsrm:
	cvsrm $(HTML)

clean:
	/bin/rm -f *.html

makelinks:
	@if [ ! -d graphics ]; then ln -f -s ../graphics .; fi
	@if [ ! -d pictures ]; then ln -f -s ../pictures .; fi
	@if [ ! -f index.html ]; then ln -f -s INTRO.html index.html ; fi



%.html:	../latex/%.tex mltex2html mltex.thm
	perl mltex2html ../latex/$(@:.html=.tex)

mlrisc.html:	$(TEX) 
mltexdoc.html:	../latex/mltex.tex

=== MLRISC/c-call/test/Makefile ===
ML_BUILD_FLAGS =	-Ctdp.instrument=true \$$smlnj-tdp/back-trace.cm

build-sparc:
#no TDP for sparc
	ml-build sources.cm SparcTest.main test-main
	sml @SMLcmdname=test-main @SMLload=test-main
	gcc -g -c mlrisc.s
	gcc -g  -c glue.c
	gcc -g  -c sanity.c
	gcc -g  mlrisc.o glue.o sanity.o -o sanity
	gcc -g  -c main.c
	gcc -g  mlrisc.o glue.o main.o -o main
	./main > main.out
	./sanity > sanity.out
	diff main.out sanity.out

build-x86-64:
	ml-build $(ML_BUILD_FLAGS) sources.cm X86_64Test.main test-main
	sml @SMLcmdname=test-main @SMLload=test-main
	gcc -g -m64 -c mlrisc.s
	gcc -g  -m64 -c glue.c
	gcc -g  -m64 -c sanity.c
	gcc -g  -m64 mlrisc.o glue.o sanity.o -o sanity
	gcc -g  -m64 -c main.c
	gcc -g  -m64 mlrisc.o glue.o main.o -o main
	./main > main.out
	./sanity > sanity.out
	diff -Naur main.out sanity.out

X86_FLAGS=-m32 -march=i686 -g

build-x86:
	ml-build $(ML_BUILD_FLAGS) sources.cm X86Test.main test-main
	sml @SMLcmdname=test-main @SMLload=test-main
	gcc $(X86_FLAGS)  -c mlrisc.s
	gcc $(X86_FLAGS)   -c glue.c
	gcc $(X86_FLAGS)   -c sanity.c
	gcc $(X86_FLAGS) -S glue.c
	gcc $(X86_FLAGS)   mlrisc.o glue.o sanity.o -o sanity
	gcc $(X86_FLAGS)   -c main.c
	gcc $(X86_FLAGS)   mlrisc.o glue.o main.o -o main
	./main > main.out
	./sanity > sanity.out
	diff -Naur main.out sanity.out

clean:
	rm -rf *.s *.c *.o main sanity *~ .cm *.out test-main*

=== debian/changelog ===
smlnj (110.78-2) unstable; urgency=medium

  * Ensure build-dir is created before build-indep tries to use it.
  * Fix FTBFS on powerpc.

 -- James McCoy <jamessan@debian.org>  Wed, 22 Jul 2015 23:19:56 -0400

smlnj (110.78-1) unstable; urgency=medium

  * New upstream release
  * debian/mkorig: Handle the new doc tarball.
  * Switch to 3.0 (quilt) source format
  * Fix i386 build on Linux 4.x kernels.  (Closes: #790283)
  * Replace Debian man pages with new upstream man pages.
  * Perform build in a build directory for easy cleanup.

 -- James McCoy <jamessan@debian.org>  Wed, 22 Jul 2015 00:02:09 -0400

smlnj (110.76-2) unstable; urgency=medium

  * debian/control: Add Vcs-* fields
  * debian/rules: Actually build Arch: all packages when build/binary targets
    are used.
  * Include documentation for ml-burg, ml-lex, and ml-yacc
    + control: Add texlive-generic-recommended and transfig to
      Build-Depends-Indep
    + rules: Convert tree.fig to tree.ps to build ml-burg documentation
    + smlnj-doc: Install ml-burg, ml-lex, and ml-yacc manuals
    + Add doc-base registration for ml-burg, ml-lex, and ml-yacc
  * Update man pages to refer to installed documentation  (Closes: #752914)
  * Bump Standards-Version to 3.9.5, no changes required

 -- James McCoy <jamessan@debian.org>  Sat, 28 Jun 2014 23:25:06 -0400

smlnj (110.76-1) unstable; urgency=low

  * New upstream version.
    + Fix comparisons of Int64 on amd64.  (Closes: #709459)

 -- James McCoy <jamessan@debian.org>  Mon, 16 Sep 2013 21:48:08 -0400

smlnj (110.75-1) unstable; urgency=low

  * New upstream version.
  * Use interest-noawait for smlnj-runtime.

 -- James McCoy <jamessan@debian.org>  Wed, 08 May 2013 20:08:08 -0400

smlnj (110.74-2) unstable; urgency=low

  * Stop shipping /usr/lib/smlnj/bin/mkorig.  This is just used for packaging
    purposes.
  * Install config/extrapathconfig as seed for pathconfig trigger.  (Closes:
    #689123)
  * Add /usr/lib/smlnj trigger to smlnj-runtime to allow updating pathconfig
    automatically.
  * Remove {pkg-,}{de,}register scripts.  Updating pathconfig is now handled
    by triggers.
  * Remove no longer needed postinst/prerm maintainer scripts.
  * Add Breaks for packages installing files under /usr/lib/smlnj

 -- James McCoy <jamessan@debian.org>  Fri, 05 Oct 2012 20:46:53 -0400

smlnj (110.74-1) unstable; urgency=low

  * New upstream release.
    + Fixes building on 3.x kernels.
  * Remove sparc from Architecture list.

 -- James McCoy <jamessan@debian.org>  Sat, 18 Feb 2012 22:46:38 -0500

smlnj (110.73-2) unstable; urgency=low

  * Only set {build,binary}-arch as a prerequisite for the {build,binary}
    targets.

 -- James McCoy <jamessan@debian.org>  Fri, 20 Jan 2012 18:00:42 -0500

smlnj (110.73-1) unstable; urgency=low

  * New upstream version.
  * Use DEB_BUILD_OPTIONS=nodoc to disable building of documentation.
  * Declare source format 1.0
  * Lintian fixes:
    + Remove HISTORY from libckit-smlnj.docs, already installed as upstream
      changelog.
    + Remove leading article from libckit-smlnj's short description.

 -- James McCoy <jamessan@debian.org>  Wed, 18 Jan 2012 20:33:37 -0500

smlnj (110.72-1) unstable; urgency=low

  * New upstream release.
    - Upstream has integrated a patch I forwarded to remove bashisms.
      (Closes: #530119)
  * Switch to debhelper compat level 7.
  * debian/control:
    - Replace obsolete tetex-extra with texlive-latex-extra in
      Build-Depends-Indep. (Closes: #562359)
    - Remove dvipdfmx from Build-Depends-Indep (superfluous).
    - Remove dvi2ps from Build-Depends-Indep (in texlive-binaries)
    - New maintainer (Closes: #428273)
    - Update to Debian Policy 3.8.4.
    - Move smlnj-doc to Section: doc to follow Debian override file.
    - Remove duplicate words from descriptions
    - Expand and correct short and long descriptions for almost all
      shipped packages. (Closes: #493601)
    - Renable sparc in Architecture line.
    - Add ${misc:Depends} to binary packages for debhelper.
  * debian/dirs: Deleted, superfluous file.
  * debian/libckit-smlnj.doc-base: Added doc-base registration.
  * debian/{libmlnlffi-smlnj,ml-lpt}.docs: Don't ship pdf documentation in
    these packages; it is already shipped in smlnj-doc.
  * debian/mkorig: Modified script so it can be called automatically by
    uscan.
  * debian/{ml-ulex.1,ml-antlr.1,ml-lpt.manpages}: Add missing manpages for
    these two binaries.
  * debian/README.Debian: Updated to reflect changes to debian/mkorig.
  * debian/rules:
    - Add dh_installchangelog calls for libckit-smlnj.
    - Update to reflect namechange of templates in debian directory.
    - Use dh_prep instead of dh_clean -k.
    - Switch to separate unpack-source target and update .PHONY.
  * debian/smlnj.docs: Don't ship latex source in binary.
  * debian/smlnj-doc.doc-base.*: Register all documentation in smlnj-doc
    with doc-base.
  * debian/smlnj-doc.prerm: Remove this file; it was needed to fix a bug
    related to upgrades from smlnj-doc_110.67-3. This version predates Lenny
    and was never in a release of Debian stable.
  * debian/watch: Added commented watch file which calls debian/mkorig.
  * debian/{_wrapper,_postinst,_prerm}: Rename templates to filename.in.
  * debian/patches/use-psfig-not-epsfig.diff: SML/NJ's documentation still
    includes deprecated calls to psfig.sty, which has been removed from
    Debian. This patch uses the wrapper epsfig.sty. Long term, upstream
    has been encouraged to port SML/NJ to use the graphicx package.
  
 -- Daniel Moerner <dmoerner@gmail.com>  Wed, 24 Feb 2010 02:53:56 -0800

smlnj (110.69-1) unstable; urgency=low

  * Orphaned package.
  * New upstream release.
  * Standards-Version 3.8.1 (no changes necessary).
  * Use 110.68's bootstrap images instead of 110.69's.

 -- Kari Pahula <kaol@debian.org>  Sat, 06 Jun 2009 14:54:02 +0300

smlnj (110.67-4) unstable; urgency=low



=== debian/control ===
Source: smlnj
Section: devel
Priority: optional
Maintainer: James McCoy <jamessan@debian.org>
Build-Depends: debhelper (>= 7), gcc-multilib [amd64]
Build-Depends-Indep: texlive-latex-base, texlive-pictures, texlive-math-extra, texlive-latex-recommended, transfig, texlive-generic-extra, texlive-latex-extra, ghostscript, texlive-binaries, texlive-generic-recommended, transfig
Standards-Version: 3.9.5
Homepage: http://www.smlnj.org/
Vcs-Git: git://anonscm.debian.org/collab-maint/smlnj.git
Vcs-Browser: https://anonscm.debian.org/gitweb/?p=collab-maint/smlnj.git

Package: smlnj
Architecture: i386 amd64 powerpc
Depends: ${misc:Depends}, smlnj-runtime (= ${binary:Version})
Replaces: sml-nj
Recommends: libsmlnj-smlnj
Suggests: smlnj-doc
Description: Standard ML of New Jersey interactive compiler
 SML/NJ is an implementation of the Standard ML programming language.
 Standard ML has many features, including type safety, polymorphism,
 algebraic data types with pattern matching, higher-order functions,
 and a sophisticated module system. It is especially well-suited for
 writing compilers and other language processors.
 .
 This package includes the interactive compiler (sml), the compilation
 manager (CM), and some essential libraries.  It is a "working"
 version, but believed to be stable.
 .
 Install this package if you want to program in SML.

Package: smlnj-doc
Architecture: all
Section: doc
Depends: ${misc:Depends}
Suggests: smlnj
Description: Documentation for Standard ML of New Jersey
 This package contains various documentation for SML/NJ, an
 implementation of the Standard ML programming language.
 .
 More documentation can be found on the web site.

Package: smlnj-runtime
Architecture: i386 amd64 powerpc
Depends: ${misc:Depends}, ${shlibs:Depends}
Breaks: libckit-smlnj (<< 110.74-2~), libcml-smlnj (<< 110.74-2~),
 libcmlutil-smlnj (<< 110.74-2~), libexene-smlnj (<< 110.74-2~),
 libmlnlffi-smlnj (<< 110.74-2~), libmlrisctools-smlnj (<< 110.74-2~),
 libpgraphutil-smlnj (<< 110.74-2~), libsmlnj-smlnj (<< 110.74-2~),
 ml-burg (<< 110.74-2~), ml-lex (<< 110.74-2~), ml-lpt (<< 110.74-2~),
 ml-nlffigen (<< 110.74-2~), ml-yacc (<< 110.74-2~), nowhere (<< 110.74-2~),
 smlnj (<< 110.74-2~)
Description: Standard ML of New Jersey runtime system
 SML/NJ is an implementation of the Standard ML programming language.
 This package includes the runtime system only -- it provides garbage
 collection and other support for compiled SML programs.
 .
 Install this package if you want to run programs compiled with SML/NJ.

Package: libsmlnj-smlnj
Architecture: i386 amd64 powerpc
Depends: ${misc:Depends}, smlnj (= ${binary:Version})
Description: Useful libraries for Standard ML of New Jersey
 A library for SML, including:
  * Util        A general utility library.
  * Controls    A library of support code for managing application controls.
  * HashCons    A library supporting hash-consing of data structures and
                efficient sets and maps using hash-consed keys.
  * HTML        Provides parsing and pretty printing of HTML.
  * INet        Networking utilities.
  * PP          Pretty-printing library.
  * Reactive    A low-level reactive scripting library.
  * RegExp      Regular-expression library.
  * Unix        A set of unix specific utilities.

Package: ml-lex
Architecture: i386 amd64 powerpc
Depends: ${misc:Depends}, smlnj-runtime (= ${binary:Version})
Description: Lexical analyzer generator for Standard ML
 Lexical analysis is the problem of segmenting input into words and
 recognizing different classes of words.  ml-lex uses regular
 expressions to describe classes of words.  It transforms a simple
 declarative language specification into an efficient SML program for
 analyzing that language.
 .
 Install this package if you want to produce a lexer in Standard ML.

Package: ml-yacc
Architecture: i386 amd64 powerpc
Depends: ${misc:Depends}, smlnj-runtime (= ${binary:Version})
Description: Parser generator for Standard ML
 SML version of the yacc program, generates a parser for a LALR language.
 This package is useful for SML developers requiring a parser in their
 work.

Package: ml-burg
Architecture: i386 amd64 powerpc
Depends: ${misc:Depends}, ml-lex (= ${binary:Version})
Description: Code generator generator for Standard ML
 ml-burg generates a Standard ML program to perform bottom-up
 rewriting of an input tree.  Cost information associated with each
 rewrite rule is used to derive the minimum rewrite cost for the
 entire tree.  A successful reduction corresponds to rewriting the
 input tree to a special non-terminal symbol called the "start"
 non-terminal.  Upon successful reduction, facilities are provided to
 walk the tree emitting semantic actions corresponding to the rules
 that matched.
 .
 Install this package if you want to write a compiler in SML using a
 burg specification.

Package: libpgraphutil-smlnj
Architecture: i386 amd64 powerpc
Depends: ${misc:Depends}, smlnj (= ${binary:Version})
Description: Portable graph utility library for SML Compilation Manager
 Utility routines for use with portable dependency graphs. This
 package contains support to build list-of-edges dependency graphs and
 convert them back into valid SML code.

Package: libcml-smlnj
Architecture: i386 amd64 powerpc
Depends: ${misc:Depends}, libsmlnj-smlnj (= ${binary:Version})
Description: Concurrent ML extension of SML
 An SML library for message-passing concurrency. This library adds
 threading support to SML. Each thread is then manually executed by
 running a separate function, rather than being called directly by the
 top-level SML loop.

Package: libcmlutil-smlnj
Architecture: i386 amd64 powerpc
Depends: ${misc:Depends}, libcml-smlnj (= ${binary:Version})
Description: Concurrent ML utility library
 Not all modules in the normal SML/NJ library are thread safe. This
 library provides thread-safe implementations of these
 libraries.

Package: libexene-smlnj
Architecture: i386 amd64 powerpc
Depends: ${misc:Depends}, libcml-smlnj (= ${binary:Version}), libcmlutil-smlnj (= ${binary:Version})
Description: Concurrent ML library for the X Window System
 A multi-threaded X Window System toolkit written in Concurrent
 ML. Many other windowing toolkits, such as Xlib, register separate
 functions that are called by a centralized event processing loop. In
 contrast, eXene maintains each window and graphical object in a
 separate thread that has the ability to update itself.

Package: libckit-smlnj
Architecture: i386 amd64 powerpc
Depends: ${misc:Depends}, smlnj (= ${binary:Version})
Description: SML library for parsing and type-checking C programs
 ckit is a C front end written in SML that translates C source code (after
 preprocessing) into abstract syntax represented as a set of SML datatypes.
 It also provides facilities for extending the C language with additional
 syntactic constructs, which can be useful for implementing "C-like"
 domain-specific languages as well as C dialects.

Package: libmlnlffi-smlnj
Architecture: i386 amd64 powerpc
Depends: ${misc:Depends}, smlnj (= ${binary:Version})
Recommends: ml-nlffigen
Description: No Longer Foreign Function Interface
 Allows ML programs to inspect and manipulate C data structures
 directly. This is implemented through three separate libraries, one
 that provides a user-code accessible frontend, one that
 implements this, and another that handles low-level raw memory
 access.

Package: ml-nlffigen
Architecture: i386 amd64 powerpc
Depends: ${misc:Depends}, libsmlnj-smlnj (= ${binary:Version}), libckit-smlnj (= ${binary:Version})
Description: ML generator for C glue code
 This tool reads in C source code and outputs ML code and a CM
 description file for use with the ML "No Longer Foreign Function
 Interface" library. This tool works by separating each top-level C
 declaration into a new ML source file. For large programs, this
 puts some strain on the SML Compilation Manager, but this should only
 marginally increase the program run-time.

Package: libmlrisctools-smlnj
Architecture: i386 amd64 powerpc
Depends: ${misc:Depends}, smlnj (= ${binary:Version})
Description: Library for generating MLRISC modules
 The MLRISC system allows an easy way to create a back-end to convert
 SML into machine code. These tools provide an easy way to generate
 MLRISC modules from machine descriptions.

Package: nowhere
Architecture: i386 amd64 powerpc
Depends: ${misc:Depends}, libmlrisctools-smlnj (= ${binary:Version})
Description: Translates programs from an extended Standard ML to Standard ML
 This is a source-to-source translation tool that expands case
 expressions that use conditional patterns. Conditional patterns that
 use the "where" keyword are converted into SML.

Package: ml-lpt
Architecture: i386 amd64 powerpc
Depends: ${misc:Depends}, smlnj (= ${binary:Version})
Provides: ml-ulex, ml-antlr
Description: SML/NJ language processing tools
 Tradition has it that when a new programming language is introduced,
 new scanner and parser generators are written in that language, and
 generate code for that language.  Traditional also has it that the
 new tools are modeled after the old lex and yacc tools, both in terms
 of the algorithms used, and often the syntax as well.  The language
 Standard ML is no exception: ml-lex and ml-yacc are the SML
 incarnations of the old Unix tools.
 .
 This package has two new tools, ml-ulex and ml-antlr, that follow
 tradition in separating scanning from parsing, but break from
 tradition in their implementation: ml-ulex is based on regular
 expression derivatives rather than subset-construction, and ml-antlr
 is based on LL(k) parsing rather than LALR(1) parsing.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

export DH_OPTIONS

SHELL:=/bin/sh

ROOT:=$(CURDIR)/build-dir

CONFIGDIR:=$(ROOT)/config
SRCDIR:=$(ROOT)/src
BS_SML:=$(ROOT)/bootstrap/bin/sml
BS_LINK:=$(ROOT)/bootstrap/bin/.link-sml

SMLNJ_HOME:=/usr/lib/smlnj
BINDIR:=$(SMLNJ_HOME)/bin
HEAPDIR:=$(BINDIR)/heap
RUNDIR:=$(BINDIR)/run
LIBDIR:=$(BINDIR)/lib

VERSION=$(shell cat $(CONFIGDIR)/version)

srcdirs:=ckit cml config doc eXene heap2asm ml-burg ml-lex ml-lpt MLRISC ml-yacc nlffi pgraph smlnj-c smlnj-lib trace-debug-profile
basedirs:=cm compiler runtime system

notlibs:=smlnj-runtime smlnj-doc
libpkgs:=$(filter-out $(notlibs),$(shell dh_listpackages))

vars.sed:
	echo "s,@SHELL@,$(SHELL),g" > vars.sed
	echo "s,@SMLNJ_HOME@,$(SMLNJ_HOME)," >> vars.sed
	echo "s,@BINDIR@,$(BINDIR)," >> vars.sed
	echo "s,@VERSION@,$(VERSION)," >> vars.sed

arch-n-opsys: $(CONFIGDIR)/_arch-n-opsys vars.sed
	cat $< | sed -f vars.sed > $@
	chmod 777 $@

$(BS_SML):
	for f in $(srcdirs); do cp -a $$f $(ROOT)/bootstrap; done
	mkdir -p $(ROOT)/bootstrap/base
	for f in $(basedirs); do cp -a base/$$f $(ROOT)/bootstrap/base; done
	cd $(ROOT)/bootstrap && URLGETTER=/bin/false ./config/install.sh

boot.%.tgz: $(BS_SML)
	cd $(ROOT)/base/system && echo "CMB.make();" | $< "\$$smlnj/cmb.cm";
	cd $(ROOT)/base/system/sml.boot.$* \
	   && $(BS_LINK) @SMLboot=BOOTLIST @SMLheap=sml @SMLalloc=1M \
	                 @SMLrebuild="foo"
	rm -r $(ROOT)/base/system/sml.boot.$*
	rm -r $(ROOT)/base/system/*.bin.$*
	mv $(ROOT)/base/system/foo.boot.$* $(ROOT)/base/system/sml.boot.$*
	cd $(ROOT)/base/system && tar zcf $(ROOT)/$@ sml.boot.$*;

boot: arch-n-opsys
	eval `./arch-n-opsys` && $(MAKE) -f debian/rules boot.$$ARCH-unix.tgz;

smlnj: boot
	cd $(ROOT) && ./config/install.sh
	
	mkdir -p $(ROOT)/wrapper
	for c in `cd $(ROOT)/bin && ls`; do \
	  cat debian/wrapper.in | sed -f vars.sed -e "s/@CMD@/$$c/g" > $(ROOT)/wrapper/$$c; \
	  chmod 555 $(ROOT)/wrapper/$$c; \
	done

$(ROOT):
	mkdir -p $(ROOT)
	for d in $$(ls -A | grep -v -e debian -e build-dir); do cp -a $$d $(ROOT); done

# Architecture
build: build-arch-stamp build-indep-stamp

build-arch: build-arch-stamp
build-arch-stamp: $(ROOT)
	cp debian/targets build-dir/config/targets
	$(MAKE) -f debian/rules smlnj
	
	touch $@

build-indep: build-indep-stamp
build-indep-stamp: $(ROOT)
ifeq (,$(filter nodoc,$(DEB_BUILD_OPTIONS)))
	cd $(ROOT)/base/cm/Doc; latex manual.tex && latex manual.tex && dvipdfmx -o cm_manual.pdf manual.dvi
	cd $(ROOT)/ml-lpt/doc; latex manual.tex && latex manual.tex && dvipdfmx -o ml-lpt_manual.pdf manual.dvi
	cd $(ROOT)/ml-burg/doc; transfig -L ps tree.fig && make && latex doc.tex && latex doc.tex && dvipdfmx -o ml-burg_manual.pdf doc.dvi
	cd $(ROOT)/nlffi/lib/Doc/manual; latex nlffi.tex && latex nlffi.tex && dvipdfmx nlffi.dvi
	cd $(ROOT)/MLRISC/Doc; make
	cd $(ROOT)/MLRISC/Tools/Doc; make
	cd $(ROOT)/ml-lex; latex lexgen.tex && latex lexgen.tex && dvipdfmx lexgen.dvi
	cd $(ROOT)/ml-yacc/doc; latex mlyacc.tex && latex mlyacc.tex && dvipdfmx mlyacc.dvi
endif
	touch $@

clean:
	dh_testdir
	dh_testroot
	rm -f *-stamp
	
	rm -rf $(ROOT)
	rm -f vars.sed
	rm -f arch-n-opsys
	rm -f boot*tgz
	rm -rf $(SRCDIR)/system/foo.* $(SRCDIR)/system/sml.*
	
	rm -rf sml.boot.*
	
	dh_clean

install: install-arch-stamp install-indep-stamp

install-indep: build-indep-stamp
	dh_testdir
	dh_testroot
	dh_installdirs -i
	dh_install -i --list-missing

install-arch: build-arch-stamp
	dh_testdir
	dh_testroot
	dh_prep
	dh_installdirs -s
	
	dh_installchangelogs -psmlnj base/compiler/ChangeLog upstream
	dh_installchangelogs -plibcml-smlnj cml/CHANGES upstream
	dh_installchangelogs -plibexene-smlnj eXene/CHANGES upstream
	dh_installchangelogs -plibsmlnj-smlnj smlnj-lib/CHANGES upstream
	dh_installchangelogs -plibckit-smlnj ckit/HISTORY upstream
	
	dh_install -s --list-missing
	
# make sure that the build path doesn't sneak in the link and run scripts
	sed -i 's/BIN_DIR=".*smlnj.*"/BIN_DIR="\/usr\/lib\/smlnj\/bin\/"/' $(CURDIR)/debian/smlnj-runtime/usr/lib/smlnj/bin/.*-sml
# install extrapathconfig rules to smlnj-runtime package to use as a seed for
# the trigger-generated pathconfig file
	install -m 644 config/extrapathconfig $(CURDIR)/debian/smlnj-runtime/usr/lib/smlnj/lib/
	echo bindir ../bin >> $(CURDIR)/debian/smlnj-runtime/usr/lib/smlnj/lib/extrapathconfig

binary-arch: install-arch
	dh_testdir -a
	dh_testroot -a 
	dh_installchangelogs -a
	dh_installdocs --exclude=".cvsignore" -a
	dh_installexamples --exclude=".cvsignore" -a
	dh_installman -a
	dh_strip -a
	dh_compress -a
	dh_fixperms -a
	dh_installdeb -a
	dh_shlibdeps -a
	dh_gencontrol -a
	dh_md5sums -a
	dh_builddeb -a

binary-indep: install-indep
	dh_testdir -i
	dh_testroot -i 
	dh_installchangelogs -i
	dh_installdocs --exclude=".cvsignore" -i
	dh_installexamples --exclude=".cvsignore" -i
	dh_installman -i
	dh_strip -i
	dh_compress -i
	dh_fixperms -i
	dh_installdeb -i
	dh_shlibdeps -i
	dh_gencontrol -i
	dh_md5sums -i
	dh_builddeb -i

binary: binary-arch binary-indep
.PHONY: build build-arch build-indep clean binary-arch binary-indep binary install install-arch install-indep

## smlnj 110.79

=== MLRISC/Doc/Makefile ===
#
# Build all documentation
#

all:
	(cd pictures; make)
	(cd html; make)
	(cd latex; make)

clean:
	(cd pictures; make clean)
	(cd html; make clean)
	(cd latex; make clean)

=== debian/changelog ===
smlnj (110.79-8build1) noble; urgency=high

  * No change rebuild against frame pointers and time_t.

 -- Julian Andres Klode <juliank@ubuntu.com>  Mon, 22 Apr 2024 11:51:23 +0200

smlnj (110.79-8) unstable; urgency=medium

  * Patch to not fail configuration for kernel 5+

 -- Barak A. Pearlmutter <bap@debian.org>  Mon, 03 Oct 2022 19:40:38 +0100

smlnj (110.79-7) unstable; urgency=medium

  [ Debian Janitor ]
  * Trim trailing whitespace.
  * Use secure URI in debian/watch.
  * Use secure URI in Homepage field.

  [ Barak A. Pearlmutter ]
  * Cherry-pick upstream copyright fix as patch (closes: #998154)
  * Bump debhelper from old 9 to 13.
  * Update standards version to 4.6.1, no changes needed.
  * Rules do not require root.
  * Adopt package (closes: #837735)

 -- Barak A. Pearlmutter <bap@debian.org>  Mon, 03 Oct 2022 09:27:56 +0100

smlnj (110.79-6) unstable; urgency=medium

  * QA upload.
  * debian/control:
    + Recover git packaging repo and use the one under Salsa Debian
      group.
    + Bump Standards-Version to 4.4.1.
    + Mark package smlnj-doc as M-A: foreign.

 -- Boyuan Yang <byang@debian.org>  Fri, 11 Oct 2019 13:07:18 -0400

smlnj (110.79-5) unstable; urgency=medium

  * QA upload.
  * Build-depend on texlive-plain-generic instead of obsolete texlive-
    generic-extra and texlive-generic-recommended. Closes: #933588.
  * Drop references to obsolete anonscm.debian.org.

 -- Steve Langasek <vorlon@debian.org>  Sat, 28 Sep 2019 22:12:41 -0700

smlnj (110.79-4) unstable; urgency=medium

  * QA upload.
  * Fix "FTBFS: Unescaped left brace in regex is illegal here in regex":
    extend debian/patches/mltex2html-perl-fixes to escape literal opening
    braces in mltex2html script.
    (Closes: #871335)

 -- gregor herrmann <gregoa@debian.org>  Tue, 08 Aug 2017 11:46:37 -0400

smlnj (110.79-3) unstable; urgency=medium

  * QA upload.
  * Update the build dependency from texlive-math-extra
    to texlive-science.
  * Fix a spelling error in the ml-burg package description.

 -- Adrian Bunk <bunk@debian.org>  Mon, 03 Jul 2017 23:15:53 +0300

smlnj (110.79-2) unstable; urgency=medium

  * Add mltex2html-perl-fixes patch.  Fixes FTBFS when '.' is not part of @INC
    (Closes: #837263) and unescaped '{' in regex.
  * Orphan package and set Maintainer to QA Group.

 -- James McCoy <jamessan@debian.org>  Tue, 13 Sep 2016 21:41:59 -0400

smlnj (110.79-1) unstable; urgency=medium

  * New upstream release.
    + Remove all patches, merged upstream.
  * Add latexmk Build-Depends-Indep for new documentation build process.
  * Use secure URLs for Vcs-*
  * Remove obsolete Breaks from transition to triggers
  * Declare compliance with policy 3.9.8, no changes required

 -- James McCoy <jamessan@debian.org>  Thu, 04 Aug 2016 00:08:01 -0400

=== debian/control ===
--- 
+++ 
@@ -1,17 +1,28 @@
 Source: smlnj
 Section: devel
 Priority: optional
-Maintainer: James McCoy <jamessan@debian.org>
-Build-Depends: debhelper (>= 7), gcc-multilib [amd64]
-Build-Depends-Indep: texlive-latex-base, texlive-pictures, texlive-math-extra, texlive-latex-recommended, transfig, texlive-generic-extra, texlive-latex-extra, ghostscript, texlive-binaries, texlive-generic-recommended, transfig
-Standards-Version: 3.9.5
-Homepage: http://www.smlnj.org/
-Vcs-Git: git://anonscm.debian.org/collab-maint/smlnj.git
-Vcs-Browser: https://anonscm.debian.org/gitweb/?p=collab-maint/smlnj.git
+Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
+XSBC-Original-Maintainer: Barak A. Pearlmutter <bap@debian.org>
+Build-Depends: debhelper-compat (= 13), gcc-multilib [amd64]
+Build-Depends-Indep: ghostscript,
+                     latexmk,
+                     texlive-binaries,
+                     texlive-plain-generic,
+                     texlive-latex-base,
+                     texlive-latex-extra,
+                     texlive-latex-recommended,
+                     texlive-science,
+                     texlive-pictures,
+                     transfig
+Standards-Version: 4.6.1
+Rules-Requires-Root: no
+Homepage: https://www.smlnj.org/
+Vcs-Git: https://salsa.debian.org/debian/smlnj.git
+Vcs-Browser: https://salsa.debian.org/debian/smlnj
 
 Package: smlnj
-Architecture: i386 amd64 powerpc
-Depends: ${misc:Depends}, smlnj-runtime (= ${binary:Version})
+Architecture: amd64 i386 powerpc
+Depends: smlnj-runtime (= ${binary:Version}), ${misc:Depends}
 Replaces: sml-nj
 Recommends: libsmlnj-smlnj
 Suggests: smlnj-doc
@@ -30,6 +41,7 @@
 
 Package: smlnj-doc
 Architecture: all
+Multi-Arch: foreign
 Section: doc
 Depends: ${misc:Depends}
 Suggests: smlnj
@@ -40,15 +52,8 @@
  More documentation can be found on the web site.
 
 Package: smlnj-runtime
-Architecture: i386 amd64 powerpc
+Architecture: amd64 i386 powerpc
 Depends: ${misc:Depends}, ${shlibs:Depends}
-Breaks: libckit-smlnj (<< 110.74-2~), libcml-smlnj (<< 110.74-2~),
- libcmlutil-smlnj (<< 110.74-2~), libexene-smlnj (<< 110.74-2~),
- libmlnlffi-smlnj (<< 110.74-2~), libmlrisctools-smlnj (<< 110.74-2~),
- libpgraphutil-smlnj (<< 110.74-2~), libsmlnj-smlnj (<< 110.74-2~),
- ml-burg (<< 110.74-2~), ml-lex (<< 110.74-2~), ml-lpt (<< 110.74-2~),
- ml-nlffigen (<< 110.74-2~), ml-yacc (<< 110.74-2~), nowhere (<< 110.74-2~),
- smlnj (<< 110.74-2~)
 Description: Standard ML of New Jersey runtime system
  SML/NJ is an implementation of the Standard ML programming language.
  This package includes the runtime system only -- it provides garbage
@@ -57,8 +62,8 @@
  Install this package if you want to run programs compiled with SML/NJ.
 
 Package: libsmlnj-smlnj
-Architecture: i386 amd64 powerpc
-Depends: ${misc:Depends}, smlnj (= ${binary:Version})
+Architecture: amd64 i386 powerpc
+Depends: smlnj (= ${binary:Version}), ${misc:Depends}
 Description: Useful libraries for Standard ML of New Jersey
  A library for SML, including:
   * Util        A general utility library.
@@ -73,8 +78,8 @@
   * Unix        A set of unix specific utilities.
 
 Package: ml-lex
-Architecture: i386 amd64 powerpc
-Depends: ${misc:Depends}, smlnj-runtime (= ${binary:Version})
+Architecture: amd64 i386 powerpc
+Depends: smlnj-runtime (= ${binary:Version}), ${misc:Depends}
 Description: Lexical analyzer generator for Standard ML
  Lexical analysis is the problem of segmenting input into words and
  recognizing different classes of words.  ml-lex uses regular
@@ -85,17 +90,17 @@
  Install this package if you want to produce a lexer in Standard ML.
 
 Package: ml-yacc
-Architecture: i386 amd64 powerpc
-Depends: ${misc:Depends}, smlnj-runtime (= ${binary:Version})
+Architecture: amd64 i386 powerpc
+Depends: smlnj-runtime (= ${binary:Version}), ${misc:Depends}
 Description: Parser generator for Standard ML
  SML version of the yacc program, generates a parser for a LALR language.
  This package is useful for SML developers requiring a parser in their
  work.
 
 Package: ml-burg
-Architecture: i386 amd64 powerpc
-Depends: ${misc:Depends}, ml-lex (= ${binary:Version})
-Description: Code generator generator for Standard ML
+Architecture: amd64 i386 powerpc
+Depends: ml-lex (= ${binary:Version}), ${misc:Depends}
+Description: Code generator for Standard ML
  ml-burg generates a Standard ML program to perform bottom-up
  rewriting of an input tree.  Cost information associated with each
  rewrite rule is used to derive the minimum rewrite cost for the
@@ -109,16 +114,16 @@
  burg specification.
 
 Package: libpgraphutil-smlnj
-Architecture: i386 amd64 powerpc
-Depends: ${misc:Depends}, smlnj (= ${binary:Version})
+Architecture: amd64 i386 powerpc
+Depends: smlnj (= ${binary:Version}), ${misc:Depends}
 Description: Portable graph utility library for SML Compilation Manager
  Utility routines for use with portable dependency graphs. This
  package contains support to build list-of-edges dependency graphs and
  convert them back into valid SML code.
 
 Package: libcml-smlnj
-Architecture: i386 amd64 powerpc
-Depends: ${misc:Depends}, libsmlnj-smlnj (= ${binary:Version})
+Architecture: amd64 i386 powerpc
+Depends: libsmlnj-smlnj (= ${binary:Version}), ${misc:Depends}
 Description: Concurrent ML extension of SML
  An SML library for message-passing concurrency. This library adds
  threading support to SML. Each thread is then manually executed by
@@ -126,16 +131,18 @@
  top-level SML loop.
 
 Package: libcmlutil-smlnj
-Architecture: i386 amd64 powerpc
-Depends: ${misc:Depends}, libcml-smlnj (= ${binary:Version})
+Architecture: amd64 i386 powerpc
+Depends: libcml-smlnj (= ${binary:Version}), ${misc:Depends}
 Description: Concurrent ML utility library
  Not all modules in the normal SML/NJ library are thread safe. This
  library provides thread-safe implementations of these
  libraries.
 
 Package: libexene-smlnj
-Architecture: i386 amd64 powerpc
-Depends: ${misc:Depends}, libcml-smlnj (= ${binary:Version}), libcmlutil-smlnj (= ${binary:Version})
+Architecture: amd64 i386 powerpc
+Depends: libcml-smlnj (= ${binary:Version}),
+         libcmlutil-smlnj (= ${binary:Version}),
+         ${misc:Depends}
 Description: Concurrent ML library for the X Window System
  A multi-threaded X Window System toolkit written in Concurrent
  ML. Many other windowing toolkits, such as Xlib, register separate
@@ -144,8 +151,8 @@
  separate thread that has the ability to update itself.
 
 Package: libckit-smlnj
-Architecture: i386 amd64 powerpc
-Depends: ${misc:Depends}, smlnj (= ${binary:Version})
+Architecture: amd64 i386 powerpc
+Depends: smlnj (= ${binary:Version}), ${misc:Depends}
 Description: SML library for parsing and type-checking C programs
  ckit is a C front end written in SML that translates C source code (after
  preprocessing) into abstract syntax represented as a set of SML datatypes.
@@ -154,8 +161,8 @@
  domain-specific languages as well as C dialects.
 
 Package: libmlnlffi-smlnj
-Architecture: i386 amd64 powerpc
-Depends: ${misc:Depends}, smlnj (= ${binary:Version})
+Architecture: amd64 i386 powerpc
+Depends: smlnj (= ${binary:Version}), ${misc:Depends}
 Recommends: ml-nlffigen
 Description: No Longer Foreign Function Interface
  Allows ML programs to inspect and manipulate C data structures
@@ -165,8 +172,10 @@
  access.
 
 Package: ml-nlffigen
-Architecture: i386 amd64 powerpc
-Depends: ${misc:Depends}, libsmlnj-smlnj (= ${binary:Version}), libckit-smlnj (= ${binary:Version})
+Architecture: amd64 i386 powerpc
+Depends: libckit-smlnj (= ${binary:Version}),
+         libsmlnj-smlnj (= ${binary:Version}),
+         ${misc:Depends}
 Description: ML generator for C glue code
  This tool reads in C source code and outputs ML code and a CM
  description file for use with the ML "No Longer Foreign Function
@@ -176,25 +185,25 @@
  marginally increase the program run-time.
 
 Package: libmlrisctools-smlnj
-Architecture: i386 amd64 powerpc
-Depends: ${misc:Depends}, smlnj (= ${binary:Version})
+Architecture: amd64 i386 powerpc
+Depends: smlnj (= ${binary:Version}), ${misc:Depends}
 Description: Library for generating MLRISC modules
  The MLRISC system allows an easy way to create a back-end to convert
  SML into machine code. These tools provide an easy way to generate
  MLRISC modules from machine descriptions.
 
 Package: nowhere
-Architecture: i386 amd64 powerpc
-Depends: ${misc:Depends}, libmlrisctools-smlnj (= ${binary:Version})
+Architecture: amd64 i386 powerpc
+Depends: libmlrisctools-smlnj (= ${binary:Version}), ${misc:Depends}
 Description: Translates programs from an extended Standard ML to Standard ML
  This is a source-to-source translation tool that expands case
  expressions that use conditional patterns. Conditional patterns that
  use the "where" keyword are converted into SML.
 
 Package: ml-lpt
-Architecture: i386 amd64 powerpc
-Depends: ${misc:Depends}, smlnj (= ${binary:Version})
-Provides: ml-ulex, ml-antlr
+Architecture: amd64 i386 powerpc
+Depends: smlnj (= ${binary:Version}), ${misc:Depends}
+Provides: ml-antlr, ml-ulex
 Description: SML/NJ language processing tools
  Tradition has it that when a new programming language is introduced,
  new scanner and parser generators are written in that language, and

=== debian/rules ===
--- 
+++ 
@@ -21,7 +21,7 @@
 VERSION=$(shell cat $(CONFIGDIR)/version)
 
 srcdirs:=ckit cml config doc eXene heap2asm ml-burg ml-lex ml-lpt MLRISC ml-yacc nlffi pgraph smlnj-c smlnj-lib trace-debug-profile
-basedirs:=cm compiler runtime system
+basedirs:=cm compiler old-basis runtime system
 
 notlibs:=smlnj-runtime smlnj-doc
 libpkgs:=$(filter-out $(notlibs),$(shell dh_listpackages))
@@ -113,13 +113,13 @@
 	dh_testdir
 	dh_testroot
 	dh_installdirs -i
-	dh_install -i --list-missing
+	dh_install -i
 
 install-arch: build-arch-stamp
 	dh_testdir
 	dh_testroot
 	dh_prep
-	dh_installdirs -s
+	dh_installdirs -a
 	
 	dh_installchangelogs -psmlnj base/compiler/ChangeLog upstream
 	dh_installchangelogs -plibcml-smlnj cml/CHANGES upstream
@@ -127,7 +127,7 @@
 	dh_installchangelogs -plibsmlnj-smlnj smlnj-lib/CHANGES upstream
 	dh_installchangelogs -plibckit-smlnj ckit/HISTORY upstream
 	
-	dh_install -s --list-missing
+	dh_install -a
 	
 # make sure that the build path doesn't sneak in the link and run scripts
 	sed -i 's/BIN_DIR=".*smlnj.*"/BIN_DIR="\/usr\/lib\/smlnj\/bin\/"/' $(CURDIR)/debian/smlnj-runtime/usr/lib/smlnj/bin/.*-sml
@@ -138,12 +138,12 @@
 
 binary-arch: install-arch
 	dh_testdir -a
-	dh_testroot -a 
+	dh_testroot -a
 	dh_installchangelogs -a
 	dh_installdocs --exclude=".cvsignore" -a
 	dh_installexamples --exclude=".cvsignore" -a
 	dh_installman -a
-	dh_strip -a
+	dh_strip -a --no-automatic-dbgsym
 	dh_compress -a
 	dh_fixperms -a
 	dh_installdeb -a
@@ -154,12 +154,11 @@
 
 binary-indep: install-indep
 	dh_testdir -i
-	dh_testroot -i 
+	dh_testroot -i
 	dh_installchangelogs -i
 	dh_installdocs --exclude=".cvsignore" -i
 	dh_installexamples --exclude=".cvsignore" -i
 	dh_installman -i
-	dh_strip -i
 	dh_compress -i
 	dh_fixperms -i
 	dh_installdeb -i

=== debian/watch ===
# This watchfile will call the debian/mkorig script, which will
# download the individual parts of the upstream distribution and construct
# a tarball from them in the directory below the source directory.
#
# For this watchfile to download the tarball, you will need to run:
#
# $ chmod +x debian/mkorig
#

version=3
https://www.smlnj.org/ \
		      dist/working/(.*)/index.html \
                debian debian/mkorig
